commit 80c605c875fb394212164908151bf0f8665f0391
Author: Andre Vieira <andre.simoesdiasvieira@arm.com>
Date:   Wed Apr 29 15:42:27 2020 +0100

    aarch64: Force TImode values into even registers
    
    The LSE CASP instruction requires values to be placed in even
    register pairs.  A solution involving two additional register
    classes was rejected in favor of the much simpler solution of
    simply requiring all TImode values to be aligned.
    
    gcc/ChangeLog:
    2020-04-29  Andre Vieira  <andre.simoesdiasvieira@arm.com>
    
            Backport from mainline.
            2018-10-31  Richard Henderson  <richard.henderson@linaro.org>
    
            * config/aarch64/aarch64.c (aarch64_hard_regno_mode_ok): Force
            16-byte modes held in GP registers to use an even regno.

diff --git a/gcc/ChangeLog b/gcc/ChangeLog
index 96eeb2791d6..3fbb6cc36f2 100644
--- a/gcc/ChangeLog
+++ b/gcc/ChangeLog
@@ -1,3 +1,11 @@
+2020-04-29  Andre Vieira  <andre.simoesdiasvieira@arm.com>
+
+	Backport from mainline.
+	2018-10-31  Richard Henderson  <richard.henderson@linaro.org>
+
+	* config/aarch64/aarch64.c (aarch64_hard_regno_mode_ok): Force
+	16-byte modes held in GP registers to use an even regno.
+
 2020-04-28  Andre Vieira  <andre.simoesdiasvieira@arm.com>
 
 	PR target/94814
diff --git a/gcc/config/aarch64/aarch64.c b/gcc/config/aarch64/aarch64.c
index 5eec1aae54a..525deba56ea 100644
--- a/gcc/config/aarch64/aarch64.c
+++ b/gcc/config/aarch64/aarch64.c
@@ -1369,10 +1369,14 @@ aarch64_hard_regno_mode_ok (unsigned regno, machine_mode mode)
   if (regno == FRAME_POINTER_REGNUM || regno == ARG_POINTER_REGNUM)
     return mode == Pmode;
 
-  if (GP_REGNUM_P (regno) && known_le (GET_MODE_SIZE (mode), 16))
-    return true;
-
-  if (FP_REGNUM_P (regno))
+  if (GP_REGNUM_P (regno))
+    {
+      if (known_le (GET_MODE_SIZE (mode), 8))
+	return true;
+      else if (known_le (GET_MODE_SIZE (mode), 16))
+	return (regno & 1) == 0;
+    }
+  else if (FP_REGNUM_P (regno))
     {
       if (vec_flags & VEC_STRUCT)
 	return end_hard_regno (mode, regno) - 1 <= V31_REGNUM;

